#include <u.h>
#include <libc.h>
#include <bio.h>
#include "misc.h"

char *func;
Biobuf bout;

void
usage(void)
{
	fprint(2,"usage: rdline_demo -f func file\n");
	exits("usage");
}

void
doit_rdline(int fd)
{
	char *p;
	Rdbuf *rb;
	rb = rdinit(fd, 32*1024);
	while((p = rdline(rb))){/* assign = */
		;
	}
}

void
doit_Brdline(int fd)
{
	char *p;
	Biobufhdr bin;
	uchar biobuf[32*1024];
	if(Binits(&bin, fd, OREAD, biobuf, sizeof(biobuf)) < 0)
		sysfatal("input not open: %r");
	while((p = Brdline(&bin, '\n'))){ /* assign = */
		;
	}
}

void
doit_Brdstr(int fd)
{
	char *p;
	Biobufhdr bin;
	uchar biobuf[32*1024];
	if(Binits(&bin, fd, OREAD, biobuf, sizeof(biobuf)) < 0)
		sysfatal("input not open: %r");
	while((p = Brdstr(&bin,'\n',1))){ /* assign = */
		;
	}
}

void
main(int argc, char *argv[])
{
	int fd;
	
	ARGBEGIN{
	case 'f': func = EARGF(usage());
		break;
	default: usage();
	}ARGEND

	if(*argv == nil)
		usage();

	if(!func)
		usage();

	Binit(&bout, 1, OWRITE);

	fd = open(*argv,OREAD);
	if(fd < 0)
		sysfatal("%s not open: %r",*argv);

	if(strcmp(func,"rdline") == 0)
		doit_rdline(fd);
	else
	if(strcmp(func,"Brdline") == 0)
		doit_Brdline(fd);
	else
	if(strcmp(func,"Brdstr") == 0)
		doit_Brdstr(fd);
	else
		usage();

	close(fd);
	Bterm(&bout);
	exits(nil);
}
