#include <u.h>
#include <libc.h>
#include <ctype.h>
#include <bio.h>

Biobuf	bout;

void
usage(void)
{
	fprint(2,"usage: tolower [file ...]\n"
		"	tolower lowers runes in files\n"
		);
	exits("usage");
}

static void
doit(char *file)
{
	int fd = 0;
	Biobuf bin;
	long c;

	if(file != nil){
		fd = open(file, OREAD);
		if(fd < 0)
			sysfatal("%s not open: %r", file);
	}

	Binit(&bin, fd, OREAD);

	/*	Bgetrune calls Bgetc to read the bytes of the next UTF
	*	sequence in the input stream and returns the value of the
	*	rune represented by the sequence.  It returns a negative
	*	value at end of file. 	*/
		
	while((c = Bgetrune(&bin)) >= 0){
		c = tolowerrune(c);
		Bputrune(&bout, c);
	}
	Bterm(&bin); // note: Bterm close the file
}

void
main(int argc, char *argv[])
{
	ARGBEGIN{
	default: usage();
	}ARGEND

	Binit(&bout, 1, OWRITE);

	if(*argv == nil){
		doit(nil);
		exits(nil);
	}

	while(*argv)
		doit(*argv++);
	Bterm(&bout);
	exits(nil);
}
